Index: drivers/filesystems/btrfs/extent-tree.c
===================================================================
--- drivers/filesystems/btrfs/extent-tree.c	(révision 75772)
+++ drivers/filesystems/btrfs/extent-tree.c	(copie de travail)
@@ -1,17 +1,17 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
@@ -19,7 +19,7 @@
 
 typedef struct {
     UINT8 type;
-    
+
     union {
         EXTENT_DATA_REF edr;
         SHARED_DATA_REF sdr;
@@ -26,64 +26,11 @@
         TREE_BLOCK_REF tbr;
         SHARED_BLOCK_REF sbr;
     };
-    
+
     UINT64 hash;
     LIST_ENTRY list_entry;
 } extent_ref;
 
-static __inline ULONG get_extent_data_len(UINT8 type) {
-    switch (type) {
-        case TYPE_TREE_BLOCK_REF:
-            return sizeof(TREE_BLOCK_REF);
-            
-        case TYPE_EXTENT_DATA_REF:
-            return sizeof(EXTENT_DATA_REF);
-            
-        case TYPE_EXTENT_REF_V0:
-            return sizeof(EXTENT_REF_V0);
-            
-        case TYPE_SHARED_BLOCK_REF:
-            return sizeof(SHARED_BLOCK_REF);
-            
-        case TYPE_SHARED_DATA_REF:
-            return sizeof(SHARED_DATA_REF);
-            
-        default:
-            return 0;
-    }
-}
-
-static __inline UINT64 get_extent_data_refcount(UINT8 type, void* data) {
-    switch (type) {
-        case TYPE_TREE_BLOCK_REF:
-            return 1;
-            
-        case TYPE_EXTENT_DATA_REF:
-        {
-            EXTENT_DATA_REF* edr = (EXTENT_DATA_REF*)data;
-            return edr->count;
-        }
-        
-        case TYPE_EXTENT_REF_V0:
-        {
-            EXTENT_REF_V0* erv0 = (EXTENT_REF_V0*)data;
-            return erv0->count;
-        }
-        
-        case TYPE_SHARED_BLOCK_REF:
-            return 1;
-        
-        case TYPE_SHARED_DATA_REF:
-        {
-            SHARED_DATA_REF* sdr = (SHARED_DATA_REF*)data;
-            return sdr->count;
-        }
-            
-        default:
-            return 0;
-    }
-}
-
 UINT64 get_extent_data_ref_hash2(UINT64 root, UINT64 objid, UINT64 offset) {
     UINT32 high_crc = 0xffffffff, low_crc = 0xffffffff;
 
@@ -90,7 +37,7 @@
     high_crc = calc_crc32c(high_crc, (UINT8*)&root, sizeof(UINT64));
     low_crc = calc_crc32c(low_crc, (UINT8*)&objid, sizeof(UINT64));
     low_crc = calc_crc32c(low_crc, (UINT8*)&offset, sizeof(UINT64));
-    
+
     return ((UINT64)high_crc << 31) ^ (UINT64)low_crc;
 }
 
@@ -120,7 +67,7 @@
     while (!IsListEmpty(extent_refs)) {
         LIST_ENTRY* le = RemoveHeadList(extent_refs);
         extent_ref* er = CONTAINING_RECORD(le, extent_ref, list_entry);
-        
+
         ExFreePool(er);
     }
 }
@@ -128,34 +75,34 @@
 static NTSTATUS add_shared_data_extent_ref(LIST_ENTRY* extent_refs, UINT64 parent, UINT32 count) {
     extent_ref* er2;
     LIST_ENTRY* le;
-    
+
     if (!IsListEmpty(extent_refs)) {
         le = extent_refs->Flink;
-        
+
         while (le != extent_refs) {
             extent_ref* er = CONTAINING_RECORD(le, extent_ref, list_entry);
-            
+
             if (er->type == TYPE_SHARED_DATA_REF && er->sdr.offset == parent) {
                 er->sdr.count += count;
                 return STATUS_SUCCESS;
             }
-            
+
             le = le->Flink;
         }
     }
-    
+
     er2 = ExAllocatePoolWithTag(PagedPool, sizeof(extent_ref), ALLOC_TAG);
     if (!er2) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     er2->type = TYPE_SHARED_DATA_REF;
     er2->sdr.offset = parent;
     er2->sdr.count = count;
-    
+
     InsertTailList(extent_refs, &er2->list_entry);
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -162,31 +109,31 @@
 static NTSTATUS add_shared_block_extent_ref(LIST_ENTRY* extent_refs, UINT64 parent) {
     extent_ref* er2;
     LIST_ENTRY* le;
-    
+
     if (!IsListEmpty(extent_refs)) {
         le = extent_refs->Flink;
-        
+
         while (le != extent_refs) {
             extent_ref* er = CONTAINING_RECORD(le, extent_ref, list_entry);
-            
+
             if (er->type == TYPE_SHARED_BLOCK_REF && er->sbr.offset == parent)
                 return STATUS_SUCCESS;
-            
+
             le = le->Flink;
         }
     }
-    
+
     er2 = ExAllocatePoolWithTag(PagedPool, sizeof(extent_ref), ALLOC_TAG);
     if (!er2) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     er2->type = TYPE_SHARED_BLOCK_REF;
     er2->sbr.offset = parent;
-    
+
     InsertTailList(extent_refs, &er2->list_entry);
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -193,79 +140,118 @@
 static NTSTATUS add_tree_block_extent_ref(LIST_ENTRY* extent_refs, UINT64 root) {
     extent_ref* er2;
     LIST_ENTRY* le;
-    
+
     if (!IsListEmpty(extent_refs)) {
         le = extent_refs->Flink;
-        
+
         while (le != extent_refs) {
             extent_ref* er = CONTAINING_RECORD(le, extent_ref, list_entry);
-            
+
             if (er->type == TYPE_TREE_BLOCK_REF && er->tbr.offset == root)
                 return STATUS_SUCCESS;
-            
+
             le = le->Flink;
         }
     }
-    
+
     er2 = ExAllocatePoolWithTag(PagedPool, sizeof(extent_ref), ALLOC_TAG);
     if (!er2) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     er2->type = TYPE_TREE_BLOCK_REF;
     er2->tbr.offset = root;
-    
+
     InsertTailList(extent_refs, &er2->list_entry);
-    
+
     return STATUS_SUCCESS;
 }
 
+static void sort_extent_refs(LIST_ENTRY* extent_refs) {
+    LIST_ENTRY newlist;
+
+    if (IsListEmpty(extent_refs))
+        return;
+
+    // insertion sort
+
+    InitializeListHead(&newlist);
+
+    while (!IsListEmpty(extent_refs)) {
+        extent_ref* er = CONTAINING_RECORD(RemoveHeadList(extent_refs), extent_ref, list_entry);
+        LIST_ENTRY* le;
+        BOOL inserted = FALSE;
+
+        le = newlist.Flink;
+        while (le != &newlist) {
+            extent_ref* er2 = CONTAINING_RECORD(le, extent_ref, list_entry);
+
+            if (er->type < er2->type || (er->type == er2->type && er->hash > er2->hash)) {
+                InsertHeadList(le->Blink, &er->list_entry);
+                inserted = TRUE;
+                break;
+            }
+
+            le = le->Flink;
+        }
+
+        if (!inserted)
+            InsertTailList(&newlist, &er->list_entry);
+    }
+
+    newlist.Flink->Blink = extent_refs;
+    newlist.Blink->Flink = extent_refs;
+    extent_refs->Flink = newlist.Flink;
+    extent_refs->Blink = newlist.Blink;
+}
+
 static NTSTATUS construct_extent_item(device_extension* Vcb, UINT64 address, UINT64 size, UINT64 flags, LIST_ENTRY* extent_refs,
-                                      KEY* firstitem, UINT8 level, PIRP Irp, LIST_ENTRY* rollback) {
+                                      KEY* firstitem, UINT8 level, PIRP Irp) {
+    NTSTATUS Status;
     LIST_ENTRY *le, *next_le;
     UINT64 refcount;
-    ULONG inline_len;
+    UINT16 inline_len;
     BOOL all_inline = TRUE;
-    extent_ref* first_noninline;
+    extent_ref* first_noninline = NULL;
     EXTENT_ITEM* ei;
     UINT8* siptr;
-    
+
     // FIXME - write skinny extents if is tree and incompat flag set
-    
+
     if (IsListEmpty(extent_refs)) {
         WARN("no extent refs found\n");
         return STATUS_SUCCESS;
     }
-    
+
     refcount = 0;
     inline_len = sizeof(EXTENT_ITEM);
-    
+
     if (flags & EXTENT_ITEM_TREE_BLOCK)
         inline_len += sizeof(EXTENT_ITEM2);
-    
+
     le = extent_refs->Flink;
     while (le != extent_refs) {
         extent_ref* er = CONTAINING_RECORD(le, extent_ref, list_entry);
         UINT64 rc;
-        
+
         next_le = le->Flink;
-        
+
         rc = get_extent_data_refcount(er->type, &er->edr);
-        
+
         if (rc == 0) {
             RemoveEntryList(&er->list_entry);
-            
+
             ExFreePool(er);
         } else {
-            ULONG extlen = get_extent_data_len(er->type);
-            
+            UINT16 extlen = get_extent_data_len(er->type);
+
             refcount += rc;
-            
+
             er->hash = get_extent_hash(er->type, &er->edr);
-            
+
             if (all_inline) {
-                if (inline_len + 1 + extlen > Vcb->superblock.node_size / 4) {
+                if ((UINT16)(inline_len + 1 + extlen) > Vcb->superblock.node_size >> 2) {
                     all_inline = FALSE;
                     first_noninline = er;
                 } else
@@ -272,23 +258,23 @@
                     inline_len += extlen + 1;
             }
         }
-        
+
         le = next_le;
     }
-    
+
     ei = ExAllocatePoolWithTag(PagedPool, inline_len, ALLOC_TAG);
     if (!ei) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     ei->refcount = refcount;
     ei->generation = Vcb->superblock.generation;
     ei->flags = flags;
-    
+
     if (flags & EXTENT_ITEM_TREE_BLOCK) {
         EXTENT_ITEM2* ei2 = (EXTENT_ITEM2*)&ei[1];
-        
+
         if (firstitem) {
             ei2->firstitem.obj_id = firstitem->obj_id;
             ei2->firstitem.obj_type = firstitem->obj_type;
@@ -298,106 +284,128 @@
             ei2->firstitem.obj_type = 0;
             ei2->firstitem.offset = 0;
         }
-        
+
         ei2->level = level;
-        
+
         siptr = (UINT8*)&ei2[1];
     } else
         siptr = (UINT8*)&ei[1];
-    
-    // Do we need to sort the inline extent refs? The Linux driver doesn't seem to bother.
-    
+
+    sort_extent_refs(extent_refs);
+
     le = extent_refs->Flink;
     while (le != extent_refs) {
         extent_ref* er = CONTAINING_RECORD(le, extent_ref, list_entry);
         ULONG extlen = get_extent_data_len(er->type);
-        
+
         if (!all_inline && er == first_noninline)
             break;
-        
+
         *siptr = er->type;
         siptr++;
-        
+
         if (extlen > 0) {
             RtlCopyMemory(siptr, &er->edr, extlen);
             siptr += extlen;
         }
-         
+
         le = le->Flink;
     }
-    
-    if (!insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_EXTENT_ITEM, size, ei, inline_len, NULL, Irp, rollback)) {
-        ERR("error - failed to insert item\n");
+
+    Status = insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_EXTENT_ITEM, size, ei, inline_len, NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         ExFreePool(ei);
-        return STATUS_INTERNAL_ERROR;
+        return Status;
     }
-    
+
     if (!all_inline) {
         le = &first_noninline->list_entry;
-        
+
         while (le != extent_refs) {
             extent_ref* er = CONTAINING_RECORD(le, extent_ref, list_entry);
-            ULONG len = get_extent_data_len(er->type);
+            UINT16 len;
             UINT8* data;
-            
-            if (len > 0) {
+
+            if (er->type == TYPE_EXTENT_DATA_REF) {
+                len = sizeof(EXTENT_DATA_REF);
+
                 data = ExAllocatePoolWithTag(PagedPool, len, ALLOC_TAG);
-                
+
                 if (!data) {
                     ERR("out of memory\n");
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 RtlCopyMemory(data, &er->edr, len);
-            } else
+            } else if (er->type == TYPE_SHARED_DATA_REF) {
+                len = sizeof(UINT32);
+
+                data = ExAllocatePoolWithTag(PagedPool, len, ALLOC_TAG);
+
+                if (!data) {
+                    ERR("out of memory\n");
+                    return STATUS_INSUFFICIENT_RESOURCES;
+                }
+
+                *((UINT32*)data) = er->sdr.count;
+            } else {
+                len = 0;
                 data = NULL;
-            
-            if (!insert_tree_item(Vcb, Vcb->extent_root, address, er->type, er->hash, data, len, NULL, Irp, rollback)) {
-                ERR("error - failed to insert item\n");
-                return STATUS_INTERNAL_ERROR;
             }
-            
+
+            Status = insert_tree_item(Vcb, Vcb->extent_root, address, er->type, er->hash, data, len, NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                if (data) ExFreePool(data);
+                return Status;
+            }
+
             le = le->Flink;
         }
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS convert_old_extent(device_extension* Vcb, UINT64 address, BOOL tree, KEY* firstitem, UINT8 level, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS convert_old_extent(device_extension* Vcb, UINT64 address, BOOL tree, KEY* firstitem, UINT8 level, PIRP Irp) {
     NTSTATUS Status;
     KEY searchkey;
     traverse_ptr tp, next_tp;
     LIST_ENTRY extent_refs;
     UINT64 size;
-    
+
     InitializeListHead(&extent_refs);
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = TYPE_EXTENT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
         ERR("old-style extent %llx not found\n", address);
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     size = tp.item->key.offset;
-    
-    delete_tree_item(Vcb, &tp, rollback);
-    
+
+    Status = delete_tree_item(Vcb, &tp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("delete_tree_item returned %08x\n", Status);
+        return Status;
+    }
+
     while (find_next_item(Vcb, &tp, &next_tp, FALSE, Irp)) {
         tp = next_tp;
-        
+
         if (tp.item->key.obj_id == address && tp.item->key.obj_type == TYPE_EXTENT_REF_V0 && tp.item->size >= sizeof(EXTENT_REF_V0)) {
             EXTENT_REF_V0* erv0 = (EXTENT_REF_V0*)tp.item->data;
-            
+
             if (tree) {
                 if (tp.item->key.offset == tp.item->key.obj_id) { // top of the tree
                     Status = add_tree_block_extent_ref(&extent_refs, erv0->root);
@@ -419,8 +427,12 @@
                     goto end;
                 }
             }
-            
-            delete_tree_item(Vcb, &tp, rollback);
+
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                goto end;
+            }
         }
 
         if (tp.item->key.obj_id > address || tp.item->key.obj_type > TYPE_EXTENT_REF_V0)
@@ -428,21 +440,22 @@
     }
 
     Status = construct_extent_item(Vcb, address, size, tree ? (EXTENT_ITEM_TREE_BLOCK | EXTENT_ITEM_SHARED_BACKREFS) : EXTENT_ITEM_DATA,
-                                   &extent_refs, firstitem, level, Irp, rollback);
+                                   &extent_refs, firstitem, level, Irp);
     if (!NT_SUCCESS(Status))
         ERR("construct_extent_item returned %08x\n", Status);
 
 end:
     free_extent_refs(&extent_refs);
-    
+
     return Status;
 }
 
-NTSTATUS increase_extent_refcount(device_extension* Vcb, UINT64 address, UINT64 size, UINT8 type, void* data, KEY* firstitem, UINT8 level, PIRP Irp, LIST_ENTRY* rollback) {
+NTSTATUS increase_extent_refcount(device_extension* Vcb, UINT64 address, UINT64 size, UINT8 type, void* data, KEY* firstitem, UINT8 level, PIRP Irp) {
     NTSTATUS Status;
     KEY searchkey;
     traverse_ptr tp;
-    ULONG datalen = get_extent_data_len(type), len, max_extent_item_size;
+    ULONG len, max_extent_item_size;
+    UINT16 datalen = get_extent_data_len(type);
     EXTENT_ITEM* ei;
     UINT8* ptr;
     UINT64 inline_rc, offset;
@@ -450,45 +463,43 @@
     EXTENT_ITEM* newei;
     BOOL skinny;
     BOOL is_tree = type == TYPE_TREE_BLOCK_REF || type == TYPE_SHARED_BLOCK_REF;
-    
+
     if (datalen == 0) {
         ERR("unrecognized extent type %x\n", type);
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     searchkey.obj_id = address;
     searchkey.obj_type = Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA ? TYPE_METADATA_ITEM : TYPE_EXTENT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         return Status;
     }
-    
+
     // If entry doesn't exist yet, create new inline extent item
-    
+
     if (tp.item->key.obj_id != searchkey.obj_id || (tp.item->key.obj_type != TYPE_EXTENT_ITEM && tp.item->key.obj_type != TYPE_METADATA_ITEM)) {
-        ULONG eisize;
-        EXTENT_ITEM* ei;
-        UINT8* ptr;
-        
+        UINT16 eisize;
+
         eisize = sizeof(EXTENT_ITEM);
         if (is_tree && !(Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA)) eisize += sizeof(EXTENT_ITEM2);
         eisize += sizeof(UINT8);
         eisize += datalen;
-        
+
         ei = ExAllocatePoolWithTag(PagedPool, eisize, ALLOC_TAG);
         if (!ei) {
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         ei->refcount = get_extent_data_refcount(type, data);
         ei->generation = Vcb->superblock.generation;
         ei->flags = is_tree ? EXTENT_ITEM_TREE_BLOCK : EXTENT_ITEM_DATA;
         ptr = (UINT8*)&ei[1];
-        
+
         if (is_tree && !(Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA)) {
             EXTENT_ITEM2* ei2 = (EXTENT_ITEM2*)ptr;
             ei2->firstitem = *firstitem;
@@ -495,20 +506,18 @@
             ei2->level = level;
             ptr = (UINT8*)&ei2[1];
         }
-        
+
         *ptr = type;
         RtlCopyMemory(ptr + 1, data, datalen);
-        
-        if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA && is_tree) {
-            if (!insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_METADATA_ITEM, level, ei, eisize, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
-            }
-        } else {
-            if (!insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_EXTENT_ITEM, size, ei, eisize, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
-            }
+
+        if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA && is_tree)
+            Status = insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_METADATA_ITEM, level, ei, eisize, NULL, Irp);
+        else
+            Status = insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_EXTENT_ITEM, size, ei, eisize, NULL, Irp);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
+            return Status;
         }
 
         return STATUS_SUCCESS;
@@ -520,47 +529,47 @@
     skinny = tp.item->key.obj_type == TYPE_METADATA_ITEM;
 
     if (tp.item->size == sizeof(EXTENT_ITEM_V0) && !skinny) {
-        Status = convert_old_extent(Vcb, address, is_tree, firstitem, level, Irp, rollback);
-        
+        Status = convert_old_extent(Vcb, address, is_tree, firstitem, level, Irp);
+
         if (!NT_SUCCESS(Status)) {
             ERR("convert_old_extent returned %08x\n", Status);
             return Status;
         }
 
-        return increase_extent_refcount(Vcb, address, size, type, data, firstitem, level, Irp, rollback);
+        return increase_extent_refcount(Vcb, address, size, type, data, firstitem, level, Irp);
     }
-        
+
     if (tp.item->size < sizeof(EXTENT_ITEM)) {
         ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     ei = (EXTENT_ITEM*)tp.item->data;
-    
+
     len = tp.item->size - sizeof(EXTENT_ITEM);
     ptr = (UINT8*)&ei[1];
-    
+
     if (ei->flags & EXTENT_ITEM_TREE_BLOCK && !skinny) {
         if (tp.item->size < sizeof(EXTENT_ITEM) + sizeof(EXTENT_ITEM2)) {
             ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM) + sizeof(EXTENT_ITEM2));
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         len -= sizeof(EXTENT_ITEM2);
         ptr += sizeof(EXTENT_ITEM2);
     }
-    
+
     inline_rc = 0;
-    
+
     // Loop through existing inline extent entries
-    
+
     while (len > 0) {
         UINT8 secttype = *ptr;
         ULONG sectlen = get_extent_data_len(secttype);
         UINT64 sectcount = get_extent_data_refcount(secttype, ptr + sizeof(UINT8));
-        
+
         len--;
-        
+
         if (sectlen > len) {
             ERR("(%llx,%x,%llx): %x bytes left, expecting at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, len, sectlen);
             return STATUS_INTERNAL_ERROR;
@@ -570,44 +579,49 @@
             ERR("(%llx,%x,%llx): unrecognized extent type %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, secttype);
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         // If inline extent already present, increase refcount and return
-        
+
         if (secttype == type) {
             if (type == TYPE_EXTENT_DATA_REF) {
                 EXTENT_DATA_REF* sectedr = (EXTENT_DATA_REF*)(ptr + sizeof(UINT8));
                 EXTENT_DATA_REF* edr = (EXTENT_DATA_REF*)data;
-                
+
                 if (sectedr->root == edr->root && sectedr->objid == edr->objid && sectedr->offset == edr->offset) {
                     UINT32 rc = get_extent_data_refcount(type, data);
                     EXTENT_DATA_REF* sectedr2;
-                    
+
                     newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
                     if (!newei) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     RtlCopyMemory(newei, tp.item->data, tp.item->size);
-                    
+
                     newei->refcount += rc;
-                    
+
                     sectedr2 = (EXTENT_DATA_REF*)((UINT8*)newei + ((UINT8*)sectedr - tp.item->data));
                     sectedr2->count += rc;
-                    
-                    delete_tree_item(Vcb, &tp, rollback);
-                    
-                    if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp, rollback)) {
-                        ERR("insert_tree_item failed\n");
-                        return STATUS_INTERNAL_ERROR;
+
+                    Status = delete_tree_item(Vcb, &tp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
                     }
-                    
+
+                    Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("insert_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
+
                     return STATUS_SUCCESS;
                 }
             } else if (type == TYPE_TREE_BLOCK_REF) {
                 TREE_BLOCK_REF* secttbr = (TREE_BLOCK_REF*)(ptr + sizeof(UINT8));
                 TREE_BLOCK_REF* tbr = (TREE_BLOCK_REF*)data;
-                
+
                 if (secttbr->offset == tbr->offset) {
                     TRACE("trying to increase refcount of non-shared tree extent\n");
                     return STATUS_SUCCESS;
@@ -615,37 +629,42 @@
             } else if (type == TYPE_SHARED_BLOCK_REF) {
                 SHARED_BLOCK_REF* sectsbr = (SHARED_BLOCK_REF*)(ptr + sizeof(UINT8));
                 SHARED_BLOCK_REF* sbr = (SHARED_BLOCK_REF*)data;
-                
+
                 if (sectsbr->offset == sbr->offset)
                     return STATUS_SUCCESS;
             } else if (type == TYPE_SHARED_DATA_REF) {
                 SHARED_DATA_REF* sectsdr = (SHARED_DATA_REF*)(ptr + sizeof(UINT8));
                 SHARED_DATA_REF* sdr = (SHARED_DATA_REF*)data;
-                
+
                 if (sectsdr->offset == sdr->offset) {
                     UINT32 rc = get_extent_data_refcount(type, data);
                     SHARED_DATA_REF* sectsdr2;
-                    
+
                     newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
                     if (!newei) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     RtlCopyMemory(newei, tp.item->data, tp.item->size);
-                    
+
                     newei->refcount += rc;
-                    
+
                     sectsdr2 = (SHARED_DATA_REF*)((UINT8*)newei + ((UINT8*)sectsdr - tp.item->data));
                     sectsdr2->count += rc;
-                    
-                    delete_tree_item(Vcb, &tp, rollback);
-                    
-                    if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp, rollback)) {
-                        ERR("insert_tree_item failed\n");
-                        return STATUS_INTERNAL_ERROR;
+
+                    Status = delete_tree_item(Vcb, &tp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
                     }
-                    
+
+                    Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("insert_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
+
                     return STATUS_SUCCESS;
                 }
             } else {
